xref: /haiku/configure (revision b3ece9056dd49388bee911aa095d22db604916db)
152a38012Sejakowatz#!/bin/sh
252a38012Sejakowatz#
3338b8dc3SIngo Weinhold# configure [ <options> ]
4614026d7Sshatty
5022fa244SIngo Weinhold# usage
6022fa244SIngo Weinhold#
7022fa244SIngo Weinhold# Prints usage.
8022fa244SIngo Weinhold#
9022fa244SIngo Weinholdusage()
10022fa244SIngo Weinhold{
11022fa244SIngo Weinhold	cat << EOF
12022fa244SIngo Weinhold
13022fa244SIngo WeinholdUsage: $0 <options>
14022fa244SIngo Weinholdoptions:
15e173a1ecSIngo Weinhold  --bootstrap <haikuporter> <HaikuPorts cross repo> <HaikuPorts repo>
16e173a1ecSIngo Weinhold                              Prepare for a bootstrap build. No pre-built
17e173a1ecSIngo Weinhold                              packages will be used, instead they will be built
18e173a1ecSIngo Weinhold                              from the sources (in several phases).
19e173a1ecSIngo Weinhold                              <haikuporter> is the path to the haikuporter tool
20e173a1ecSIngo Weinhold                              suitable for the host platform.
21e173a1ecSIngo Weinhold                              <HaikuPorts cross repo> is the path to a checked
22e173a1ecSIngo Weinhold                              out HaikuPorts cross-compilation repository.
23e173a1ecSIngo Weinhold                              <HaikuPorts repo> is the path to a checked out
24e173a1ecSIngo Weinhold                              HaikuPorts repository.
25c0e8cc1aSIngo Weinhold  --build-cross-tools <arch> [ <build tools dir> ]
26338b8dc3SIngo Weinhold                              Assume cross compilation. <build tools dir>
27338b8dc3SIngo Weinhold                              defines the location of the build tools sources.
28338b8dc3SIngo Weinhold                              They will be compiled and placed in the output
29a5b60fa8SOliver Tappe                              directory under "cross-tools". The HAIKU_* tools
30a5b60fa8SOliver Tappe                              variables will be set accordingly.
3120ab75e6SIngo Weinhold                              <arch> specifies the target architecture, either
32c0e8cc1aSIngo Weinhold                              "x86_gcc2", "x86", "x86_64", "ppc", "m68k", "arm",
33c0e8cc1aSIngo Weinhold                              or "mipsel".
34c0e8cc1aSIngo Weinhold                              This option and --cross-tools-prefix can be
35c0e8cc1aSIngo Weinhold                              specified multiple times. The first cross tools
36c0e8cc1aSIngo Weinhold                              specify the primary tools, the subsequent ones the
37c0e8cc1aSIngo Weinhold                              secondary tools (for "hybrid" images).
38c0e8cc1aSIngo Weinhold                              For the first --build-cross-tools the
39c0e8cc1aSIngo Weinhold                              <build tools dir> argument must be specified and
40c0e8cc1aSIngo Weinhold                              for the subsequent ones it must be omitted.
41eccc7665SIngo Weinhold  --cross-tools-prefix <prefix>
42eccc7665SIngo Weinhold                              Assume cross compilation. <prefix> should be a
43eccc7665SIngo Weinhold                              path to the directory where the cross
44eccc7665SIngo Weinhold                              compilation tools are located, plus the platform
450da9c208SIngo Weinhold                              prefix, e.g. "/path/to/tools/i586-pc-haiku-".
46eccc7665SIngo Weinhold                              This overrides the HAIKU_* tool variables.
47a66c32ddSIngo Weinhold  --distro-compatibility <level>
48a66c32ddSIngo Weinhold                              The distribution's level of compatibility with
49a66c32ddSIngo Weinhold                              the official Haiku distribution. The generated
50a66c32ddSIngo Weinhold                              files will contain the respective trademarks
51a66c32ddSIngo Weinhold                              accordingly.
52a66c32ddSIngo Weinhold                              official -- the official Haiku distribution.
53a66c32ddSIngo Weinhold                              compatible -- a Haiku Compatible (tm) distro.
54a66c32ddSIngo Weinhold                              default -- any other distro (default value).
5560d8d8fcSIngo Weinhold  --enable-multiuser          Enable experimental multiuser support.
56eccc7665SIngo Weinhold  --help                      Prints out this help.
572ebcd86dSIngo Weinhold  --host-only                 Configure for building tools for the build host
582ebcd86dSIngo Weinhold                              only. Haiku cannot be built when configured like
592ebcd86dSIngo Weinhold                              this.
60eccc7665SIngo Weinhold  --include-gpl-addons        Include GPL licensed add-ons.
6167838392SAxel Dörfler  --include-patented-code     Enable code that is known to implemented patented
6267838392SAxel Dörfler                              ideas and techniques. If this option is not
6367838392SAxel Dörfler                              specified, the resulting distribution may still
6467838392SAxel Dörfler                              implement patented ideas and techniques. This
6567838392SAxel Dörfler                              option only disables code that is currently known
6667838392SAxel Dörfler                              to be problematic.
6776fa0be3SIngo Weinhold  --include-sources           Includes the source code of projects that require
6876fa0be3SIngo Weinhold                              either an offer of source code or a copy of the
6976fa0be3SIngo Weinhold                              patched sources. This is preferable when
7076fa0be3SIngo Weinhold                              distributing on physical mediums.
711974210fSFrançois Revol  --include-3rdparty          Include 3rdparty/ in the build system.
7260d8d8fcSIngo Weinhold  -j<n>                       Only relevant for --build-cross-tools and
7360d8d8fcSIngo Weinhold                              --build-cross-tools-gcc4. Is passed on to the
7460d8d8fcSIngo Weinhold                              make building the build tools.
7586d7e283SOliver Tappe  --remote-user <username>    Use given username when logging into 
7686d7e283SOliver Tappe                              git.haiku-os.org (via ssh).
777c4641d0SOliver Tappe  --target=TARGET             Select build target platform.
787c4641d0SOliver Tappe                              [default=${TARGET_PLATFORM}]
79a17b9c0cSshatty                              valid targets=r5,bone,dano,haiku
80483b28e4SIngo Weinhold  --target-arch <arch>        Haiku only: Specify the target architecture to
81483b28e4SIngo Weinhold                              build for. Must be one of the architectures of the
82483b28e4SIngo Weinhold                              host system. The installed build tools for that
83483b28e4SIngo Weinhold                              architecture will be used.
84483b28e4SIngo Weinhold                              This option can be specified multiple times. The
85483b28e4SIngo Weinhold                              first occurrence specifies the primary
86483b28e4SIngo Weinhold                              architecture of the Haiku to build, subsequent
87483b28e4SIngo Weinhold                              ones the secondary architectures.
887c4641d0SOliver Tappe  --update                    re-runs last configure invocation [must be given
897c4641d0SOliver Tappe                              as first option!]
90eccc7665SIngo Weinhold  --use-gcc-pipe              Build with GCC option -pipe. Speeds up the build
915a34a443SFrançois Revol                              process, but uses more memory.
92ed38d2efSJerome Duval  --use-gcc-graphite          Build with GCC Graphite engine for loop
93ed38d2efSJerome Duval                              optimizations. Only for gcc 4.
940385b065SIngo Weinhold  --use-32bit                 Use -m32 flag on 64bit host gcc compiler.
95bc96e8f3SIngo Weinhold  --use-xattr                 Use Linux xattr respectively *BSD extattr support
96bc96e8f3SIngo Weinhold                              for BeOS attribute emulation. Warning: Make sure
97bc96e8f3SIngo Weinhold                              your file system supports sufficient attribute
98bc96e8f3SIngo Weinhold                              sizes (4 KB per file for all attributes won't
99bc96e8f3SIngo Weinhold                              suffice).
100bc96e8f3SIngo Weinhold  --use-xattr-ref             Use the generic BeOS attribute emulation, but use
101bc96e8f3SIngo Weinhold                              Linux xattr respectively *BSD extattr support to
102bc96e8f3SIngo Weinhold                              make it more robust (i.e. attribute mix-ups become
103bc96e8f3SIngo Weinhold                              less likely).
104338b8dc3SIngo Weinhold
105338b8dc3SIngo Weinholdenvironment variables:
106c0e8cc1aSIngo Weinhold  HAIKU_AR_x86_gcc2           The static library archiver for x86_gcc2.
107c0e8cc1aSIngo Weinhold                              Defaults to "ar".
108c0e8cc1aSIngo Weinhold  HAIKU_CC_x86_gcc2           The x86_gcc2 compiler. Defaults to "gcc".
109c0e8cc1aSIngo Weinhold  HAIKU_LD_x86_gcc2           The x86_gcc2 linker. Defaults to "ld".
110c0e8cc1aSIngo Weinhold  HAIKU_OBJCOPY_x86_gcc2      The x86_gcc2 objcopy to be used. Defaults to
111c0e8cc1aSIngo Weinhold                              "objcopy".
112c0e8cc1aSIngo Weinhold  HAIKU_RANLIB_x86_gcc2       The static library indexer for x86_gcc2. Defaults
113c0e8cc1aSIngo Weinhold                              to "ranlib".
114c0e8cc1aSIngo Weinhold  HAIKU_STRIP_x86_gcc2        The x86_gcc2 strip command. Defaults to "strip".
11577e84f21SIngo Weinhold  HAIKU_YASM                  The yasm assembler (x86 only).
116c0e8cc1aSIngo Weinhold  HAIKU_CPPFLAGS_<arch>       The preprocessor flags for target architecture
117c0e8cc1aSIngo Weinhold                              <arch>. Defaults to "".
118c0e8cc1aSIngo Weinhold  HAIKU_CCFLAGS_<arch>        The C flags for target architecture <arch>.
119c0e8cc1aSIngo Weinhold                              Defaults to "".
120c0e8cc1aSIngo Weinhold  HAIKU_CXXFLAGS_<arch>       The C++ flags for target architecture <arch>.
121c0e8cc1aSIngo Weinhold                              Defaults to "".
122c0e8cc1aSIngo Weinhold  HAIKU_LDFLAGS_<arch>        The linker flags for target architecture <arch>.
123c0e8cc1aSIngo Weinhold                              Defaults to "".
124c0e8cc1aSIngo Weinhold  HAIKU_ARFLAGS_<arch>        The flags passed to HAIKU_AR for target
125c0e8cc1aSIngo Weinhold                              architecture <arch> for archiving. Defaults to
126c0e8cc1aSIngo Weinhold                              "cru".
127c0e8cc1aSIngo Weinhold  HAIKU_UNARFLAGS_<arch>      The flags passed to HAIKU_AR for target
128c0e8cc1aSIngo Weinhold                              architecture <arch> for unarchiving. Defaults to
129c0e8cc1aSIngo Weinhold                              "x".
13064f6da31SIngo Weinhold
131c0e8cc1aSIngo WeinholdNon-default output directories:
13264f6da31SIngo Weinhold  By default all objects, build configuration, and other related files are
13364f6da31SIngo Weinhold  stored in /path/to/haiku_source/generated.  To store objects in a non-default
13464f6da31SIngo Weinhold  location, run "../../relative/path/to/haiku_source/configure <options>" from
13564f6da31SIngo Weinhold  within your non-default location.  "jam [ options ] targets" can then be run
13664f6da31SIngo Weinhold  directly inside your non-default location.  Another option is to invoke "jam
13764f6da31SIngo Weinhold  [ options ] targets" from within haiku_source.  This can be accomplished by
13864f6da31SIngo Weinhold  either "export HAIKU_OUTPUT_DIR=your non-default location" before invoking
13964f6da31SIngo Weinhold  jam or by creating a symlink of haiku_source/generated pointing to your
14064f6da31SIngo Weinhold  non-default location and running jam.
14164f6da31SIngo Weinhold
14264f6da31SIngo Weinhold
143022fa244SIngo WeinholdEOF
144022fa244SIngo Weinhold}
145022fa244SIngo Weinhold
146022fa244SIngo Weinhold# assertparam
147022fa244SIngo Weinhold#
148022fa244SIngo Weinhold# Checks whether at least one parameter is left.
149022fa244SIngo Weinhold#
150022fa244SIngo Weinholdassertparam()
151022fa244SIngo Weinhold{
15220ab75e6SIngo Weinhold	if [ $2 -lt 2 ]; then
153022fa244SIngo Weinhold		echo $0: \`$1\': Parameter expected.
154022fa244SIngo Weinhold		exit 1
155022fa244SIngo Weinhold	fi
156022fa244SIngo Weinhold}
157022fa244SIngo Weinhold
15820ab75e6SIngo Weinhold# assertparams
15920ab75e6SIngo Weinhold#
16020ab75e6SIngo Weinhold# Checks whether at least a certain number of parameters is left.
16120ab75e6SIngo Weinhold#
16220ab75e6SIngo Weinholdassertparams()
16320ab75e6SIngo Weinhold{
16420ab75e6SIngo Weinhold	if [ $3 -le $2 ]; then
16520ab75e6SIngo Weinhold		echo $0: \`$1\': Not enough parameters.
16620ab75e6SIngo Weinhold		exit 1
16720ab75e6SIngo Weinhold	fi
16820ab75e6SIngo Weinhold}
16920ab75e6SIngo Weinhold
170e173a1ecSIngo Weinhold# absolute_path
171e173a1ecSIngo Weinhold#
172e173a1ecSIngo Weinhold# returns the absolute path of a given path.
173e173a1ecSIngo Weinhold#
174e173a1ecSIngo Weinholdabsolute_path()
175e173a1ecSIngo Weinhold{
1766a4f3954SFrançois Revol	if [ "x$1" != "x${1#/}" ]; then
177e173a1ecSIngo Weinhold		echo "$1"
178e173a1ecSIngo Weinhold	else
179e173a1ecSIngo Weinhold		echo "`pwd`/$1"
180e173a1ecSIngo Weinhold	fi
181e173a1ecSIngo Weinhold}
182e173a1ecSIngo Weinhold
1839a001156SOliver Tappe# real_path
1849a001156SOliver Tappe#
1859a001156SOliver Tappe# returns the realpath of a symbolic link.
1869a001156SOliver Tappe#
1879a001156SOliver Tappereal_path()
1889a001156SOliver Tappe{
1899a001156SOliver Tappe	perl -MCwd=realpath -e'print realpath($ARGV[0]), "\n"' "$1"
1909a001156SOliver Tappe}
1919a001156SOliver Tappe
19209c5682dSIngo Weinhold# standard_gcc_settings
19309c5682dSIngo Weinhold#
19409c5682dSIngo Weinhold# Sets the variables for a GCC platform.
19509c5682dSIngo Weinhold#
19609c5682dSIngo Weinholdstandard_gcc_settings()
19709c5682dSIngo Weinhold{
198c0e8cc1aSIngo Weinhold	local gcc=$1
199c0e8cc1aSIngo Weinhold
200138f5fb4SIngo Weinhold	if which greadlink > /dev/null 2>&1; then
201b29b48b1SMatt Madia		readlink="greadlink -e"
202138f5fb4SIngo Weinhold	elif which realpath > /dev/null 2>&1; then
203b29b48b1SMatt Madia		readlink=realpath
2049a001156SOliver Tappe	elif readlink -e / > /dev/null 2>&1; then
205b29b48b1SMatt Madia		readlink="readlink -e"
2069a001156SOliver Tappe	else
2079a001156SOliver Tappe		readlink=real_path
208b4b6d83cSMatt Madia	fi
209138f5fb4SIngo Weinhold
21009c5682dSIngo Weinhold	# PLATFORM_LINKLIBS
211c0e8cc1aSIngo Weinhold	local gcclib=`$gcc -print-libgcc-file-name`
212c0e8cc1aSIngo Weinhold	local gccdir=`dirname ${gcclib}`
2135b0f7b1bSOliver Tappe
214c0e8cc1aSIngo Weinhold	local gccRawVersion=`$gcc -dumpversion`
215c0e8cc1aSIngo Weinhold	local gccMachine=`$gcc -dumpmachine`
216338b8dc3SIngo Weinhold
217c0e8cc1aSIngo Weinhold	local libgcc=${gccdir}/libgcc.a
2188b5934c9SIngo Weinhold
219fc8967f1SIngo Weinhold	# determine architecture from machine triple
220c0e8cc1aSIngo Weinhold	case $gccMachine in
221c0e8cc1aSIngo Weinhold		arm-*)		targetCpu=arm;;
222c0e8cc1aSIngo Weinhold		i?86-*)		targetCpu=x86;;
223c0e8cc1aSIngo Weinhold		m68k-*)		targetCpu=m68k;;
224c0e8cc1aSIngo Weinhold		mipsel-*)	targetCpu=mipsel;;
225c0e8cc1aSIngo Weinhold		powerpc-*)	targetCpu=ppc;;
226c0e8cc1aSIngo Weinhold		x86_64-*)	targetCpu=x86_64;;
227fc8967f1SIngo Weinhold		*)
228c0e8cc1aSIngo Weinhold			echo "Unsupported gcc target machine: $gccMachine" >&2
229fc8967f1SIngo Weinhold			exit 1
230fc8967f1SIngo Weinhold			;;
231fc8967f1SIngo Weinhold	esac
232fc8967f1SIngo Weinhold
233c0e8cc1aSIngo Weinhold	local targetArch=$targetCpu
234c0e8cc1aSIngo Weinhold	local staticLibStdCxx
235c0e8cc1aSIngo Weinhold	local sharedLibStdCxx
236c0e8cc1aSIngo Weinhold	local staticLibSupCxx
237c0e8cc1aSIngo Weinhold	local sharedLibSupCxx
238c0e8cc1aSIngo Weinhold	local kernelLibgcc
239c0e8cc1aSIngo Weinhold	local cxxHeaders
240fc8967f1SIngo Weinhold
241c0e8cc1aSIngo Weinhold	case $gccRawVersion in
2428b5934c9SIngo Weinhold		4.*)
2435b0f7b1bSOliver Tappe			# for gcc 4 we use the libstdc++ and libsupc++ that come with the
2445b0f7b1bSOliver Tappe			# compiler
245c0e8cc1aSIngo Weinhold			staticLibStdCxx=`$gcc -print-file-name=libstdc++.a`
246c0e8cc1aSIngo Weinhold			sharedLibStdCxx=`$gcc -print-file-name=libstdc++.so`
247c0e8cc1aSIngo Weinhold			staticLibSupCxx=`$gcc -print-file-name=libsupc++.a`
248c0e8cc1aSIngo Weinhold			sharedLibSupCxx=`$gcc -print-file-name=libsupc++.so`
24914210488SMichael Lotz
250aaeadfcbSAlex Smith			# If the architecture has separate runtime libraries for the
251aaeadfcbSAlex Smith			# kernel, use them.
252c0e8cc1aSIngo Weinhold			kernelLibgcc=`$gcc -print-file-name=libgcc-kernel.a`
253c0e8cc1aSIngo Weinhold			if [ $kernelLibgcc = libgcc-kernel.a ]; then
254c0e8cc1aSIngo Weinhold				kernelLibgcc=$libgcc
255aaeadfcbSAlex Smith			fi
256c0e8cc1aSIngo Weinhold			kernelLibSupCxx=`$gcc -print-file-name=libsupc++-kernel.a`
257c0e8cc1aSIngo Weinhold			if [ $kernelLibSupCxx = libsupc++-kernel.a ]; then
258c0e8cc1aSIngo Weinhold				kernelLibSupCxx=$staticLibSupCxx
259aaeadfcbSAlex Smith			fi
260aaeadfcbSAlex Smith
261c0e8cc1aSIngo Weinhold			local headersBase=$gccdir/../../../..
262c0e8cc1aSIngo Weinhold			local headers=$headersBase/$gccMachine/include/c++/$gccRawVersion
263c0e8cc1aSIngo Weinhold			if [ ! -d $headers ]; then
264c0e8cc1aSIngo Weinhold				headers=$headersBase/include/c++/$gccRawVersion
26514210488SMichael Lotz			fi
26614210488SMichael Lotz
267c0e8cc1aSIngo Weinhold			cxxHeaders=$headers
268c0e8cc1aSIngo Weinhold			for d in $gccMachine backward ext; do
26929ef597dSIngo Weinhold				# Note: We need the line break, otherwise the line might become
27029ef597dSIngo Weinhold				# too long for jam (512 bytes max).
271c0e8cc1aSIngo Weinhold				cxxHeaders="$cxxHeaders $headers/$d"
2728b5934c9SIngo Weinhold			done
273274b450aSMarcus Overhagen
2743f9f9f9aSIngo Weinhold			# Unset the HAIKU_{SHARED,STATIC}_LIB{STD,SUP}CXX variables, if the
2753f9f9f9aSIngo Weinhold			# compiler didn't give us actual file names. Otherwise resolve
2763f9f9f9aSIngo Weinhold			# symlinks to avoid problems when copying the libraries to the
2773f9f9f9aSIngo Weinhold			# image.
2788b5934c9SIngo Weinhold
279c0e8cc1aSIngo Weinhold			if [ $staticLibStdCxx = libstdc++.a ]; then
280c0e8cc1aSIngo Weinhold				staticLibStdCxx=
2813f9f9f9aSIngo Weinhold			else
282c0e8cc1aSIngo Weinhold				staticLibStdCxx=`$readlink $staticLibStdCxx`
2838b5934c9SIngo Weinhold			fi
2843f9f9f9aSIngo Weinhold
285c0e8cc1aSIngo Weinhold			if [ $sharedLibStdCxx = libstdc++.so ]; then
286c0e8cc1aSIngo Weinhold				sharedLibStdCxx=
2873f9f9f9aSIngo Weinhold			else
288c0e8cc1aSIngo Weinhold				sharedLibStdCxx=`$readlink $sharedLibStdCxx`
289ffe8b20cSIngo Weinhold			fi
2903f9f9f9aSIngo Weinhold
291c0e8cc1aSIngo Weinhold			if [ $staticLibSupCxx = libsupc++.a ]; then
292c0e8cc1aSIngo Weinhold				staticLibSupCxx=
2933f9f9f9aSIngo Weinhold			else
294c0e8cc1aSIngo Weinhold				staticLibSupCxx=`$readlink $staticLibSupCxx`
295c89fc875SIngo Weinhold			fi
2963f9f9f9aSIngo Weinhold
297c0e8cc1aSIngo Weinhold			if [ $sharedLibSupCxx = libsupc++.so ]; then
298c0e8cc1aSIngo Weinhold				sharedLibSupCxx=
2993f9f9f9aSIngo Weinhold			else
300c0e8cc1aSIngo Weinhold				sharedLibSupCxx=`$readlink $sharedLibSupCxx`
301ffe8b20cSIngo Weinhold			fi
3028b5934c9SIngo Weinhold			;;
3036cc8eecfSOliver Tappe		2.9*)
3045b0f7b1bSOliver Tappe			# check for correct (most up-to-date) legacy compiler and complain
3055b0f7b1bSOliver Tappe			# if an older one is installed
306c0e8cc1aSIngo Weinhold			if [ $gccRawVersion != $haikuRequiredLegacyGCCVersion ]; then
3075b0f7b1bSOliver Tappe				echo "GCC version $haikuRequiredLegacyGCCVersion is required!";
3085b0f7b1bSOliver Tappe				echo "Please download it from www.haiku-os.org...";
3095b0f7b1bSOliver Tappe				exit 1;
3105b0f7b1bSOliver Tappe			fi
311aaeadfcbSAlex Smith
312c0e8cc1aSIngo Weinhold			kernelLibgcc=$libgcc
313c0e8cc1aSIngo Weinhold			kernelLibSupCxx=
314c0e8cc1aSIngo Weinhold			targetArch=x86_gcc2
3155b0f7b1bSOliver Tappe			;;
3168b5934c9SIngo Weinhold	esac
31765ad1ba3SAlex Smith
318c0e8cc1aSIngo Weinhold	local bootLibgcc
319c0e8cc1aSIngo Weinhold	local bootLibSupCxx
32066a7f29fSJérôme Duval	local bootCxxHeaders
321c0e8cc1aSIngo Weinhold	case $gccMachine in
3224591ebc9SAlex Smith		x86_64-*)
32366a7f29fSJérôme Duval			# Boot loader is 32-bit, need the 32-bit libs and c++ config
324c0e8cc1aSIngo Weinhold			bootLibgcc=`$gcc -m32 -print-libgcc-file-name`
325c0e8cc1aSIngo Weinhold			bootLibSupCxx=`$gcc -m32 -print-file-name=libsupc++.a`
32666a7f29fSJérôme Duval
32766a7f29fSJérôme Duval			local headersBase=$gccdir/../../../..
32866a7f29fSJérôme Duval			local headers=$headersBase/$gccMachine/include/c++/$gccRawVersion
32966a7f29fSJérôme Duval			if [ ! -d $headers ]; then
33066a7f29fSJérôme Duval				headers=$headersBase/include/c++/$gccRawVersion
33166a7f29fSJérôme Duval			fi
33266a7f29fSJérôme Duval			bootCxxHeaders="$headers/$gccMachine/32"
3334591ebc9SAlex Smith			;;
3344591ebc9SAlex Smith		*)
335c0e8cc1aSIngo Weinhold			bootLibgcc=$libgcc
336c0e8cc1aSIngo Weinhold			bootLibSupCxx=$staticLibSupCxx
337338b8dc3SIngo Weinhold			;;
338338b8dc3SIngo Weinhold	esac
339c0e8cc1aSIngo Weinhold
340c0e8cc1aSIngo Weinhold	# determine whether graphite loop optimization should/can be used
341c0e8cc1aSIngo Weinhold	local useGraphite=`get_variable HAIKU_USE_GCC_GRAPHITE_$targetCpu`
342c0e8cc1aSIngo Weinhold	if [ -z "$useGraphite" ]; then
343c0e8cc1aSIngo Weinhold		useGraphite=$useGccGraphiteDefault
344c0e8cc1aSIngo Weinhold	fi
345c0e8cc1aSIngo Weinhold
346c0e8cc1aSIngo Weinhold	if [ "$useGraphite" != 0 ]; then
347c0e8cc1aSIngo Weinhold		UNUSED=`echo "int main() {}" | $gcc -xc -c -floop-block - 2>&1`
348c0e8cc1aSIngo Weinhold		if [ $? != 0 ]; then
349c0e8cc1aSIngo Weinhold			echo "GCC Graphite loop optimizations cannot be used on $targetArch"
350c0e8cc1aSIngo Weinhold			useGraphite=0
351c0e8cc1aSIngo Weinhold		fi
352c0e8cc1aSIngo Weinhold	fi
353c0e8cc1aSIngo Weinhold
354c0e8cc1aSIngo Weinhold	set_variable HAIKU_CPU_$targetArch $targetCpu
355c0e8cc1aSIngo Weinhold
356c0e8cc1aSIngo Weinhold	get_build_tool_path CC_$targetArch "$gcc"
357c0e8cc1aSIngo Weinhold	set_variable HAIKU_GCC_RAW_VERSION_$targetArch $gccRawVersion
358c0e8cc1aSIngo Weinhold	set_variable HAIKU_GCC_MACHINE_$targetArch $gccMachine
359c0e8cc1aSIngo Weinhold	set_variable HAIKU_GCC_LIB_DIR_$targetArch $gccdir
360c0e8cc1aSIngo Weinhold	set_variable HAIKU_GCC_LIBGCC_$targetArch $libgcc
361c0e8cc1aSIngo Weinhold	set_variable HAIKU_GCC_GLUE_CODE_$targetArch "crtbegin.o crtend.o"
362c0e8cc1aSIngo Weinhold	set_variable HAIKU_GCC_HEADERS_DIR_$targetArch \
363c0e8cc1aSIngo Weinhold		"${gccdir}/include ${gccdir}/include-fixed"
364c0e8cc1aSIngo Weinhold	set_variable HAIKU_STATIC_LIBSTDCXX_$targetArch "$staticLibStdCxx"
365c0e8cc1aSIngo Weinhold	set_variable HAIKU_SHARED_LIBSTDCXX_$targetArch "$sharedLibStdCxx"
366c0e8cc1aSIngo Weinhold	set_variable HAIKU_STATIC_LIBSUPCXX_$targetArch "$staticLibSupCxx"
367c0e8cc1aSIngo Weinhold	set_variable HAIKU_SHARED_LIBSUPCXX_$targetArch "$sharedLibSupCxx"
368c0e8cc1aSIngo Weinhold	set_variable HAIKU_KERNEL_LIBSUPCXX_$targetArch "$kernelLibSupCxx"
369c0e8cc1aSIngo Weinhold	set_variable HAIKU_BOOT_LIBSUPCXX_$targetArch "$bootLibSupCxx"
370c0e8cc1aSIngo Weinhold	set_variable HAIKU_KERNEL_LIBGCC_$targetArch $kernelLibgcc
371c0e8cc1aSIngo Weinhold	set_variable HAIKU_CXX_HEADERS_DIR_$targetArch "$cxxHeaders"
372c0e8cc1aSIngo Weinhold	set_variable HAIKU_BOOT_LIBGCC_$targetArch $bootLibgcc
37366a7f29fSJérôme Duval	set_variable HAIKU_BOOT_CXX_HEADERS_DIR_$targetArch "$bootCxxHeaders"
374c0e8cc1aSIngo Weinhold	set_variable HAIKU_USE_GCC_GRAPHITE_$targetArch $useGraphite
375c0e8cc1aSIngo Weinhold
376c0e8cc1aSIngo Weinhold	standard_gcc_settings_targetArch=$targetArch
377c0e8cc1aSIngo Weinhold}
378c0e8cc1aSIngo Weinhold
379c0e8cc1aSIngo Weinhold# set_variable
380c0e8cc1aSIngo Weinhold#
381c0e8cc1aSIngo Weinhold# Set the value of a variable.
382c0e8cc1aSIngo Weinhold#
383c0e8cc1aSIngo Weinholdset_variable()
384c0e8cc1aSIngo Weinhold{
385c0e8cc1aSIngo Weinhold	eval "$1=\"$2\""
386c0e8cc1aSIngo Weinhold}
387c0e8cc1aSIngo Weinhold
388c0e8cc1aSIngo Weinhold# get_variable
389c0e8cc1aSIngo Weinhold#
390c0e8cc1aSIngo Weinhold# Echo the value of a variable.
391c0e8cc1aSIngo Weinhold#
392c0e8cc1aSIngo Weinholdget_variable()
393c0e8cc1aSIngo Weinhold{
394c0e8cc1aSIngo Weinhold	eval "echo \${$1}"
39509c5682dSIngo Weinhold}
39609c5682dSIngo Weinhold
397338b8dc3SIngo Weinhold# set_default_value
398338b8dc3SIngo Weinhold#
399338b8dc3SIngo Weinhold# Set the value for a variable, if no value is set yet.
400338b8dc3SIngo Weinhold#
401338b8dc3SIngo Weinholdset_default_value()
402338b8dc3SIngo Weinhold{
403338b8dc3SIngo Weinhold	eval "$1=\${$1-$2}"
404338b8dc3SIngo Weinhold}
405338b8dc3SIngo Weinhold
406338b8dc3SIngo Weinhold# get_build_tool_path
407338b8dc3SIngo Weinhold#
408338b8dc3SIngo Weinhold# Gets a usable absolute path of a build tool.
409338b8dc3SIngo Weinhold#
410338b8dc3SIngo Weinholdget_build_tool_path()
411338b8dc3SIngo Weinhold{
412338b8dc3SIngo Weinhold	local var="HAIKU_$1"
413c0e8cc1aSIngo Weinhold	local path=$2
414338b8dc3SIngo Weinhold
415338b8dc3SIngo Weinhold	if [ -f "$path" ]; then
416338b8dc3SIngo Weinhold		# get absolute path
417a559f87aSFrançois Revol		local oldPwd="`pwd`"
418a559f87aSFrançois Revol		cd "`dirname "$path"`"
419a559f87aSFrançois Revol		path="`pwd`/`basename "$path"`"
420338b8dc3SIngo Weinhold		cd $oldPwd
421338b8dc3SIngo Weinhold	else
4227fe2e06cSMatt Madia		which "$path" > /dev/null 2>&1 || {
423338b8dc3SIngo Weinhold			echo "Build tool \"$path\" not found." >&2
424338b8dc3SIngo Weinhold			exit 1
425338b8dc3SIngo Weinhold		}
426338b8dc3SIngo Weinhold	fi
427338b8dc3SIngo Weinhold
428338b8dc3SIngo Weinhold	eval "$var=$path"
429338b8dc3SIngo Weinhold}
430338b8dc3SIngo Weinhold
431483b28e4SIngo Weinholdis_in_list()
432483b28e4SIngo Weinhold{
433483b28e4SIngo Weinhold	local element
434483b28e4SIngo Weinhold	for element in $2; do
435483b28e4SIngo Weinhold		if [ "$1" = "$element" ]; then
436483b28e4SIngo Weinhold			return 0
437483b28e4SIngo Weinhold		fi
438483b28e4SIngo Weinhold	done
439483b28e4SIngo Weinhold	return 1
440483b28e4SIngo Weinhold}
441483b28e4SIngo Weinhold
442338b8dc3SIngo Weinhold# get cwd and the source directory
443338b8dc3SIngo WeinholdcurrentDir=`pwd`
4446e7c6fe5SIngo Weinholdcd `dirname "$0"`
445338b8dc3SIngo WeinholdsourceDir=`pwd`
4466e7c6fe5SIngo Weinholdcd "$currentDir"
447338b8dc3SIngo Weinhold
44855d267a4SFrançois Revol# backup the passed arguments
44955d267a4SFrançois RevolconfigureArgs="$@"
45055d267a4SFrançois Revol
4517c4641d0SOliver Tappe# internal default parameter values
452022fa244SIngo Weinhold#
45352a38012Sejakowatzplatform=`uname`
4545abd9a46SIngo WeinholdplatformMachine=`uname  -m`
455c0e8cc1aSIngo WeinholdtargetArchs=
456338b8dc3SIngo WeinholdbuildCrossTools=
45729ef597dSIngo WeinholdbuildCrossToolsScript="$sourceDir/build/scripts/build_cross_tools"
45860d8d8fcSIngo WeinholdbuildCrossToolsJobs=
459c0e8cc1aSIngo WeinholduseGccGraphiteDefault=0
460c0e8cc1aSIngo WeinholdunknownArchIndex=1
461483b28e4SIngo WeinholdhaikuTargetArchs=
4627c4641d0SOliver Tappe
4637c4641d0SOliver Tappe# exported (BuildSetup) default parameter values
4647c4641d0SOliver Tappe#
4657c4641d0SOliver TappeHOST_GCC_RAW_VERSION=`gcc -dumpversion`
4667c4641d0SOliver TappeHOST_GCC_MACHINE=`gcc -dumpmachine`
4677c4641d0SOliver TappeHAIKU_INCLUDE_GPL_ADDONS=0
4687c4641d0SOliver TappeHAIKU_INCLUDE_PATENTED_CODE=0
46976fa0be3SIngo WeinholdHAIKU_INCLUDE_SOURCES=0
4707c4641d0SOliver TappeHAIKU_INCLUDE_3RDPARTY=0
4717c4641d0SOliver TappeHAIKU_ENABLE_MULTIUSER=0
4727c4641d0SOliver TappeHAIKU_DISTRO_COMPATIBILITY=default
4737c4641d0SOliver TappeTARGET_PLATFORM=haiku
4747c4641d0SOliver TappeHAIKU_USE_GCC_PIPE=0
4757986925fSIngo WeinholdHAIKU_HOST_USE_32BIT=0
4767986925fSIngo WeinholdHAIKU_HOST_USE_XATTR=0
477bc96e8f3SIngo WeinholdHAIKU_HOST_USE_XATTR_REF=0
4782ebcd86dSIngo WeinholdHAIKU_HOST_BUILD_ONLY=0
479f04f7042SNiels Sascha ReedijkHOST_EXTENDED_REGEX_SED="sed -r"
4807c4641d0SOliver TappeHOST_GCC_LD=`gcc -print-prog-name=ld`
4817c4641d0SOliver TappeHOST_GCC_OBJCOPY=`gcc -print-prog-name=objcopy`
482c505b276SFrançois RevolSFDISK_BINARY=sfdisk
483c505b276SFrançois RevolHOST_SFDISK=$SFDISK_BINARY
4842a5d0aafSIngo WeinholdHOST_SHA256=
485e173a1ecSIngo WeinholdHOST_HAIKU_PORTER=
486e173a1ecSIngo WeinholdHAIKU_PORTS=
487e173a1ecSIngo WeinholdHAIKU_PORTS_CROSS=
4882a5d0aafSIngo Weinhold
489c0e8cc1aSIngo WeinholdHAIKU_PACKAGING_ARCHS=
490c0e8cc1aSIngo Weinhold
491c0e8cc1aSIngo Weinholdset_default_value HAIKU_YASM		yasm
492c0e8cc1aSIngo Weinhold
4933942ca0dSIngo Weinholdif sha256sum < /dev/null > /dev/null 2>&1; then
4942a5d0aafSIngo Weinhold	HOST_SHA256=sha256sum
4953942ca0dSIngo Weinholdelif sha256 < /dev/null > /dev/null 2>&1; then
4962a5d0aafSIngo Weinhold	HOST_SHA256="sha256 -q"
497b5a871b1SNiels Sascha Reedijkelif shasum < /dev/null > /dev/null 2>&1; then
498b5a871b1SNiels Sascha Reedijk	HOST_SHA256="shasum -a 256"
4992a5d0aafSIngo Weinholdelse
5002a5d0aafSIngo Weinhold	echo "Error: Neither sha256sum nor sha256 seem to be available!" >&2
5012a5d0aafSIngo Weinhold	exit 1
5022a5d0aafSIngo Weinholdfi
503338b8dc3SIngo Weinhold
504cc91b333SIngo WeinholdhaikuRequiredLegacyGCCVersion="2.95.3-haiku-2013_08_15"
505a559f87aSFrançois Revolexport haikuRequiredLegacyGCCVersion
506af4bf973SOliver Tappe	# version of legacy gcc required to build haiku
507483b28e4SIngo WeinholdsupportedTargetArchs="
508483b28e4SIngo Weinhold	arm
509483b28e4SIngo Weinhold	m68k
510483b28e4SIngo Weinhold	mipsel
511483b28e4SIngo Weinhold	ppc
512483b28e4SIngo Weinhold	x86
513483b28e4SIngo Weinhold	x86_64
514483b28e4SIngo Weinhold	x86_gcc2
515483b28e4SIngo Weinhold	"
516af4bf973SOliver Tappe
5177c4641d0SOliver Tappe# determine output directory
5187c4641d0SOliver Tappeif [ "$currentDir" = "$sourceDir" ]; then
5197c4641d0SOliver Tappe	outputDir=$currentDir/generated
5207c4641d0SOliver Tappeelse
5217c4641d0SOliver Tappe	outputDir=$currentDir
5227c4641d0SOliver Tappefi
5237c4641d0SOliver TappebuildOutputDir="$outputDir/build"
5247c4641d0SOliver TappeHAIKU_BUILD_ATTRIBUTES_DIR="$outputDir/attributes"
5257c4641d0SOliver TappebuildConfigFile="$buildOutputDir/BuildConfig"
5267c4641d0SOliver Tappe
5277c4641d0SOliver Tappe# check for update request
5287c4641d0SOliver Tappeif [ "$1" = "--update" ]; then
5297c4641d0SOliver Tappe	if ! [ -e "$buildConfigFile" ]; then
5307c4641d0SOliver Tappe		echo $0 --update: \'$buildConfigFile\' not found - updating not possible.
5317c4641d0SOliver Tappe		exit 1
5327c4641d0SOliver Tappe	fi
5337c4641d0SOliver Tappe	if ! type perl >/dev/null 2>&1; then
5347c4641d0SOliver Tappe		echo $0 --update: \'perl\' not found - updating not possible.
5357c4641d0SOliver Tappe		exit 1
5367c4641d0SOliver Tappe	fi
5377c4641d0SOliver Tappe	# convert BuildConfig from jam format to shell format and evaluate it
5387c4641d0SOliver Tappe	shellConfigFile="${buildConfigFile}.shell"
5397c4641d0SOliver Tappe	perl "$sourceDir/build/scripts/convert_build_config_to_shell_format.pl" \
5407c4641d0SOliver Tappe		<"$buildConfigFile" >"$shellConfigFile"
5417c4641d0SOliver Tappe	. "$shellConfigFile"
5427c4641d0SOliver Tappe	rm "$shellConfigFile"
5437c4641d0SOliver Tappe	shift
5447c4641d0SOliver Tappefi
5457c4641d0SOliver Tappe
546022fa244SIngo Weinhold# parse parameters
547022fa244SIngo Weinhold#
54820ab75e6SIngo Weinholdwhile [ $# -gt 0 ] ; do
549022fa244SIngo Weinhold	case "$1" in
550e173a1ecSIngo Weinhold		--bootstrap)
551e173a1ecSIngo Weinhold			assertparams "$1" 3 $#
552e173a1ecSIngo Weinhold			HOST_HAIKU_PORTER="`absolute_path $2`"
553e173a1ecSIngo Weinhold			HAIKU_PORTS_CROSS="`absolute_path $3`"
554e173a1ecSIngo Weinhold			HAIKU_PORTS="`absolute_path $4`"
555e173a1ecSIngo Weinhold			shift 4
556e173a1ecSIngo Weinhold			;;
557c0e8cc1aSIngo Weinhold		--build-cross-tools)
558c0e8cc1aSIngo Weinhold			if [ -z "$buildCrossTools" ]; then
5599b0dd528SIngo Weinhold				assertparams "$1" 2 $#
560c0e8cc1aSIngo Weinhold				targetArch=$2
5619b0dd528SIngo Weinhold				buildCrossTools=$3
5629b0dd528SIngo Weinhold				shift 3
563c0e8cc1aSIngo Weinhold			else
564c0e8cc1aSIngo Weinhold				assertparam "$1" $#
565c0e8cc1aSIngo Weinhold				targetArch=$2
566c0e8cc1aSIngo Weinhold				shift 2
567c0e8cc1aSIngo Weinhold			fi
568c0e8cc1aSIngo Weinhold			case "$targetArch" in
569c0e8cc1aSIngo Weinhold				x86_gcc2)	targetMachine=i586-pc-haiku;;
570c0e8cc1aSIngo Weinhold				x86)		targetMachine=i586-pc-haiku;;
571c0e8cc1aSIngo Weinhold				x86_64)		targetMachine=x86_64-unknown-haiku;;
572c0e8cc1aSIngo Weinhold				ppc)		targetMachine=powerpc-apple-haiku;;
573c0e8cc1aSIngo Weinhold				m68k)		targetMachine=m68k-unknown-haiku;;
574c0e8cc1aSIngo Weinhold				arm)		targetMachine=arm-unknown-haiku;;
575c0e8cc1aSIngo Weinhold				mipsel)		targetMachine=mipsel-unknown-haiku;;
576c0e8cc1aSIngo Weinhold				*)
577c0e8cc1aSIngo Weinhold					echo "Unsupported target architecture: $2" >&2
578c0e8cc1aSIngo Weinhold					exit 1
579c0e8cc1aSIngo Weinhold					;;
580c0e8cc1aSIngo Weinhold			esac
581c0e8cc1aSIngo Weinhold			set_variable buildCrossToolsMachine_$targetArch $targetMachine
582c0e8cc1aSIngo Weinhold			targetArchs="$targetArchs $targetArch"
583c0e8cc1aSIngo Weinhold			HAIKU_PACKAGING_ARCHS=
5849b0dd528SIngo Weinhold			;;
5859b0dd528SIngo Weinhold		--cross-tools-prefix)
5869b0dd528SIngo Weinhold			assertparam "$1" $#
587c0e8cc1aSIngo Weinhold			targetArch=unknown${unknownArchIndex}
588c0e8cc1aSIngo Weinhold			set_variable crossToolsPrefix_$targetArch "$2"
589c0e8cc1aSIngo Weinhold			targetArchs="$targetArchs $targetArch"
590c0e8cc1aSIngo Weinhold			HAIKU_PACKAGING_ARCHS=
591d68208faSMatt Madia			unknownArchIndex=$(($unknownArchIndex + 1))
5929b0dd528SIngo Weinhold			shift 2
5939b0dd528SIngo Weinhold			;;
594a66c32ddSIngo Weinhold		--distro-compatibility)
5959b0dd528SIngo Weinhold			assertparam "$1" $#
5967c4641d0SOliver Tappe			HAIKU_DISTRO_COMPATIBILITY=$2
5977c4641d0SOliver Tappe			case "$HAIKU_DISTRO_COMPATIBILITY" in
598a66c32ddSIngo Weinhold				official)	;;
599a66c32ddSIngo Weinhold				compatible)	;;
600a66c32ddSIngo Weinhold				default)	;;
601a66c32ddSIngo Weinhold				*)			echo "Invalid distro compatibility" \
6027c4641d0SOliver Tappe								"level: $HAIKU_DISTRO_COMPATIBILITY"
603a66c32ddSIngo Weinhold							exit 1;;
604a66c32ddSIngo Weinhold			esac
6059b0dd528SIngo Weinhold			shift 2
6069b0dd528SIngo Weinhold			;;
6077c4641d0SOliver Tappe		--enable-multiuser)	HAIKU_ENABLE_MULTIUSER=1; shift 1;;
60860d8d8fcSIngo Weinhold		--help | -h)	usage; exit 0;;
6092ebcd86dSIngo Weinhold		--host-only)	HAIKU_HOST_BUILD_ONLY=1; shift 1;;
6107c4641d0SOliver Tappe		--include-gpl-addons)	HAIKU_INCLUDE_GPL_ADDONS=1; shift 1;;
6117c4641d0SOliver Tappe		--include-patented-code)	HAIKU_INCLUDE_PATENTED_CODE=1; shift 1;;
61276fa0be3SIngo Weinhold		--include-sources)	HAIKU_INCLUDE_SOURCES=1; shift 1;;
6137c4641d0SOliver Tappe		--include-3rdparty)	HAIKU_INCLUDE_3RDPARTY=1; shift 1;;
61460d8d8fcSIngo Weinhold        -j*)				buildCrossToolsJobs="$1"; shift 1;;
6157c4641d0SOliver Tappe		--target=*)     TARGET_PLATFORM=`echo $1 | cut -d'=' -f2-`; shift 1;;
616483b28e4SIngo Weinhold		--target-arch)
617483b28e4SIngo Weinhold			assertparam "$1" $#
618483b28e4SIngo Weinhold			targetArch=$2
619483b28e4SIngo Weinhold			shift 2
620483b28e4SIngo Weinhold			if [ ! "$platform" = Haiku ]; then
621483b28e4SIngo Weinhold				echo "--target-arch can only be specified on Haiku." >&2
622483b28e4SIngo Weinhold				exit 1
623483b28e4SIngo Weinhold			fi
624483b28e4SIngo Weinhold			is_in_list "$targetArch" "$supportedTargetArchs" || (
625483b28e4SIngo Weinhold				echo "Unsupported target architecture: \"$targetArch\"" >&2
626483b28e4SIngo Weinhold				exit 1
627483b28e4SIngo Weinhold			)
628483b28e4SIngo Weinhold			haikuTargetArchs="$haikuTargetArchs $targetArch"
629483b28e4SIngo Weinhold			;;
6307c4641d0SOliver Tappe		--use-gcc-pipe)	HAIKU_USE_GCC_PIPE=1; shift 1;;
631c0e8cc1aSIngo Weinhold		--use-gcc-graphite)	useGccGraphiteDefault=1; shift 1;;
6327986925fSIngo Weinhold		--use-32bit)	HAIKU_HOST_USE_32BIT=1; shift 1;;
6337986925fSIngo Weinhold		--use-xattr)	HAIKU_HOST_USE_XATTR=1; shift 1;;
634bc96e8f3SIngo Weinhold		--use-xattr-ref)	HAIKU_HOST_USE_XATTR_REF=1; shift 1;;
635022fa244SIngo Weinhold		*)				echo Invalid argument: \`$1\'; exit 1;;
636022fa244SIngo Weinhold	esac
637022fa244SIngo Weinholddone
638022fa244SIngo Weinhold
6390df3cc9cSIngo Weinhold# detect the build platform
640338b8dc3SIngo Weinholdcase "${platform}" in
6417c4641d0SOliver Tappe	Darwin)	HOST_PLATFORM=darwin ;;
6427c4641d0SOliver Tappe	FreeBSD)	HOST_PLATFORM=freebsd
643c505b276SFrançois Revol				SFDISK_BINARY=sfdisk-linux
6447986925fSIngo Weinhold				if [ "$HAIKU_HOST_USE_32BIT" = 1 ] ; then
6455abd9a46SIngo Weinhold					echo Unsupported platform: FreeBSD ${platformMachine}
646308c212cSIngo Weinhold					exit 1
647308c212cSIngo Weinhold				fi	;;
6487c4641d0SOliver Tappe	Haiku)	HOST_PLATFORM=haiku_host ;;
6497c4641d0SOliver Tappe	Linux)	HOST_PLATFORM=linux ;;
6507c4641d0SOliver Tappe	OpenBSD) HOST_PLATFORM=openbsd ;;
6517c4641d0SOliver Tappe	SunOS)	HOST_PLATFORM=sunos ;;
6527c4641d0SOliver Tappe	CYGWIN_NT-*) HOST_PLATFORM=cygwin ;;
653338b8dc3SIngo Weinhold	*)		echo Unsupported platform: ${platform}
6544cbe4925SAxel Dörfler			exit 1 ;;
6554cbe4925SAxel Dörfleresac
65652a38012Sejakowatz
657c505b276SFrançois Revol# check common locations for sfdisk
658c505b276SFrançois Revolfor sfdiskDir in /sbin /usr/sbin /usr/local/sbin ; do
659c505b276SFrançois Revol	if [ -e ${sfdiskDir}/${SFDISK_BINARY} ]; then
660c505b276SFrançois Revol		HOST_SFDISK=${sfdiskDir}/${SFDISK_BINARY}
661c505b276SFrançois Revol	fi
662c505b276SFrançois Revoldone
663c505b276SFrançois Revol
6640962132cSAlex Smith# check for case-sensitive filesystem
6650962132cSAlex Smithmkdir haikuCaseTest 2>/dev/null
6660962132cSAlex Smithmkdir haikucasetest 2>/dev/null
6670962132cSAlex SmithcaseInsensitive=$?
66897f5a0bdSAlex Smithrmdir haikuCaseTest haikucasetest 2>/dev/null
6690962132cSAlex Smithif [ $caseInsensitive != 0 ]; then
6703ecc5287SMichael Lotz	echo "You need a case-sensitive file-system to build Haiku."
6710962132cSAlex Smith	if [ $HOST_PLATFORM = "darwin" ]; then
6720962132cSAlex Smith		echo "You can create a case-sensitive disk image using Disk Utility and use"
6730962132cSAlex Smith		echo "it to store the Haiku sources on."
6743ecc5287SMichael Lotz	fi
6750962132cSAlex Smith	exit 1
6763ecc5287SMichael Lotzfi
6773ecc5287SMichael Lotz
678f04f7042SNiels Sascha Reedijk# determine how to invoke sed with extended regexp support for non-GNU sed
679f04f7042SNiels Sascha Reedijkif [ $HOST_PLATFORM = "darwin" ]; then
680f04f7042SNiels Sascha Reedijk	HOST_EXTENDED_REGEX_SED="sed -E"
681f04f7042SNiels Sascha Reedijkfi
682f04f7042SNiels Sascha Reedijk
683338b8dc3SIngo Weinhold# create output directory
6846e7c6fe5SIngo Weinholdmkdir -p "$buildOutputDir" || exit 1
685338b8dc3SIngo Weinhold
6862ebcd86dSIngo Weinholdif [ "$HAIKU_HOST_BUILD_ONLY" = 1 ]; then
6872ebcd86dSIngo Weinhold	invalidCommand=$sourceDir/build/scripts/host_build_only
6882ebcd86dSIngo Weinhold	HAIKU_AR=$invalidCommand
6892ebcd86dSIngo Weinhold	HAIKU_CC=$invalidCommand
6902ebcd86dSIngo Weinhold	HAIKU_LD=$invalidCommand
6912ebcd86dSIngo Weinhold	HAIKU_OBJCOPY=$invalidCommand
6922ebcd86dSIngo Weinhold	HAIKU_RANLIB=$invalidCommand
6932ebcd86dSIngo Weinhold	HAIKU_ELFEDIT=$invalidCommand
6942ebcd86dSIngo Weinhold	HAIKU_YASM=$invalidCommand
6952ebcd86dSIngo Weinhold	HAIKU_STRIP=$invalidCommand
6962ebcd86dSIngo Weinholdelse
697c0e8cc1aSIngo Weinhold	if [ -n "$HAIKU_PACKAGING_ARCHS" ]; then
698c0e8cc1aSIngo Weinhold		targetArchs="$HAIKU_PACKAGING_ARCHS"
699c0e8cc1aSIngo Weinhold	fi
700c0e8cc1aSIngo Weinhold	HAIKU_PACKAGING_ARCHS=
701c0e8cc1aSIngo Weinhold
702483b28e4SIngo Weinhold	# On Haiku determine target architectures and tools automatically.
703c0e8cc1aSIngo Weinhold	if [ -z "$targetArchs" ]; then
704483b28e4SIngo Weinhold		if [ $HOST_PLATFORM != haiku_host ]; then
705483b28e4SIngo Weinhold			echo "Please specify the build tools to use or build (via" \
706eaef83a9SJeroen Oortwijn				"--cross-tools-prefix or --build-cross-tools) or specify a" \
707483b28e4SIngo Weinhold				"host-only build (--host-only)." >&2
708483b28e4SIngo Weinhold			exit 1
709483b28e4SIngo Weinhold		fi
710483b28e4SIngo Weinhold
711483b28e4SIngo Weinhold		# determine primary architecture
712dda53eaeSIngo Weinhold		targetArch=`package list -i /system/packages/haiku-*.hpkg \
713483b28e4SIngo Weinhold			| sed '/^\s*architecture:/!d; s,^\s*architecture:\s*,,'`
714483b28e4SIngo Weinhold		is_in_list "$targetArch" "$supportedTargetArchs" || (
715483b28e4SIngo Weinhold			echo "Unsupported target architecture: \"$targetArch\"" >&2
716483b28e4SIngo Weinhold			exit 1
717483b28e4SIngo Weinhold		)
718c0e8cc1aSIngo Weinhold		targetArchs=$targetArch
719483b28e4SIngo Weinhold
720c0e8cc1aSIngo Weinhold		set_default_value HAIKU_AR_$targetArch			ar
721c0e8cc1aSIngo Weinhold		set_default_value HAIKU_CC_$targetArch			gcc
722c0e8cc1aSIngo Weinhold		set_default_value HAIKU_LD_$targetArch			ld
723c0e8cc1aSIngo Weinhold		set_default_value HAIKU_OBJCOPY_$targetArch		objcopy
724c0e8cc1aSIngo Weinhold		set_default_value HAIKU_RANLIB_$targetArch		ranlib
725c0e8cc1aSIngo Weinhold		set_default_value HAIKU_ELFEDIT_$targetArch		elfedit
726c0e8cc1aSIngo Weinhold		set_default_value HAIKU_STRIP_$targetArch		strip
727483b28e4SIngo Weinhold
728483b28e4SIngo Weinhold		# determine secondary architectures
729483b28e4SIngo Weinhold		for targetArch in $supportedTargetArchs; do
73080262a91SMatt Madia			if [ -e /system/packages/haiku_$targetArch-*.hpkg ]; then
731483b28e4SIngo Weinhold				targetArchs="$targetArchs $targetArch"
732483b28e4SIngo Weinhold				set_default_value HAIKU_AR_$targetArch		ar-$targetArch
733483b28e4SIngo Weinhold				set_default_value HAIKU_CC_$targetArch		gcc-$targetArch
734483b28e4SIngo Weinhold				set_default_value HAIKU_LD_$targetArch		ld-$targetArch
735483b28e4SIngo Weinhold				set_default_value HAIKU_OBJCOPY_$targetArch	objcopy-$targetArch
736483b28e4SIngo Weinhold				set_default_value HAIKU_RANLIB_$targetArch	ranlib-$targetArch
737483b28e4SIngo Weinhold				set_default_value HAIKU_ELFEDIT_$targetArch	elfedit-$targetArch
738483b28e4SIngo Weinhold				set_default_value HAIKU_STRIP_$targetArch	strip-$targetArch
739483b28e4SIngo Weinhold			fi
740483b28e4SIngo Weinhold		done
741483b28e4SIngo Weinhold
742483b28e4SIngo Weinhold		# The target architectures might have been specified explicitly.
743483b28e4SIngo Weinhold		if [ -n "$haikuTargetArchs" ]; then
744483b28e4SIngo Weinhold			for targetArch in $haikuTargetArchs; do
745483b28e4SIngo Weinhold				is_in_list "$targetArch" "$targetArchs" || (
746483b28e4SIngo Weinhold					echo "Unsupported target architecture: \"$targetArch\"." \
747483b28e4SIngo Weinhold						"Only native architectures of the host platform can" \
748483b28e4SIngo Weinhold						"be specified." >&2
749483b28e4SIngo Weinhold					exit 1
750483b28e4SIngo Weinhold				)
751483b28e4SIngo Weinhold			done
752483b28e4SIngo Weinhold			targetArchs="$haikuTargetArchs"
753483b28e4SIngo Weinhold		fi
754c0e8cc1aSIngo Weinhold	fi
755c0e8cc1aSIngo Weinhold
75668ccc989SIngo Weinhold	isPrimaryArch=1
757c0e8cc1aSIngo Weinhold	for targetArch in $targetArchs; do
758c0e8cc1aSIngo Weinhold		# Note: targetArch is "unknown<n>" at this point, if a cross-tools
759c0e8cc1aSIngo Weinhold		# prefix was specified. The standard_gcc_settings call below will get
760c0e8cc1aSIngo Weinhold		# the actual architecture.
761c0e8cc1aSIngo Weinhold
762c0e8cc1aSIngo Weinhold		crossToolsPrefix=`get_variable crossToolsPrefix_$targetArch`
763c0e8cc1aSIngo Weinhold
764338b8dc3SIngo Weinhold		# build cross tools from sources
765c0e8cc1aSIngo Weinhold		if [ -n "$buildCrossTools" -a -z "$crossToolsPrefix" ]; then
766c0e8cc1aSIngo Weinhold			crossToolsDir="$outputDir/cross-tools-$targetArch"
767c0e8cc1aSIngo Weinhold			targetMachine=`get_variable buildCrossToolsMachine_$targetArch`
768c0e8cc1aSIngo Weinhold			script="$buildCrossToolsScript"
7698304ec7cSIngo Weinhold			scriptArgs=
770c0e8cc1aSIngo Weinhold			if [ $targetArch != x86_gcc2 ]; then
7718304ec7cSIngo Weinhold				script="${script}_gcc4"
7728304ec7cSIngo Weinhold				scriptArgs="$targetMachine"
7731e93288eSJérôme Duval				set_default_value HAIKU_USE_GCC_GRAPHITE_$targetArch	\
7741e93288eSJérôme Duval					$useGccGraphiteDefault
775c0e8cc1aSIngo Weinhold			fi
77668ccc989SIngo Weinhold			secondaryArch=
77768ccc989SIngo Weinhold			if [ -z "$isPrimaryArch" ]; then
77868ccc989SIngo Weinhold				secondaryArch=$targetArch
77968ccc989SIngo Weinhold			fi
78086de8c37SIngo Weinhold
78186de8c37SIngo Weinhold			case $HOST_PLATFORM in
78286de8c37SIngo Weinhold				freebsd|openbsd)	MAKE=gmake;;
78386de8c37SIngo Weinhold				*)					MAKE=make;;
78486de8c37SIngo Weinhold			esac
78586de8c37SIngo Weinhold
78686de8c37SIngo Weinhold			MAKE=$MAKE \
78768ccc989SIngo Weinhold			SECONDARY_ARCH=$secondaryArch \
788c0e8cc1aSIngo Weinhold			HAIKU_USE_GCC_GRAPHITE=`get_variable \
789c0e8cc1aSIngo Weinhold				HAIKU_USE_GCC_GRAPHITE_$targetArch` \
790*b3ece905SJérôme Duval			HAIKU_USE_GCC_PIPE=$HAIKU_USE_GCC_PIPE \
7918304ec7cSIngo Weinhold			"$script" $scriptArgs "$sourceDir" "$buildCrossTools" \
7928304ec7cSIngo Weinhold				"$crossToolsDir" $buildCrossToolsJobs || exit 1
793c0e8cc1aSIngo Weinhold			crossToolsPrefix="$crossToolsDir/bin/${targetMachine}-"
794338b8dc3SIngo Weinhold		fi
795338b8dc3SIngo Weinhold
796c0e8cc1aSIngo Weinhold		# prepare gcc settings and get the actual target architecture
797c0e8cc1aSIngo Weinhold		gcc="${crossToolsPrefix}gcc"
798c0e8cc1aSIngo Weinhold		if [ -z "${crossToolsPrefix}" ]; then
799c0e8cc1aSIngo Weinhold			gcc=`get_variable HAIKU_CC_$targetArch`
800338b8dc3SIngo Weinhold		fi
801c0e8cc1aSIngo Weinhold		standard_gcc_settings "$gcc"
802c0e8cc1aSIngo Weinhold		targetArch=$standard_gcc_settings_targetArch
803338b8dc3SIngo Weinhold
804c0e8cc1aSIngo Weinhold		# set default values for flags
805c0e8cc1aSIngo Weinhold		set_default_value HAIKU_CPPFLAGS_$targetArch	""
806c0e8cc1aSIngo Weinhold		set_default_value HAIKU_CCFLAGS_$targetArch		""
807c0e8cc1aSIngo Weinhold		set_default_value HAIKU_CXXFLAGS_$targetArch	""
808c0e8cc1aSIngo Weinhold		set_default_value HAIKU_LDFLAGS_$targetArch		""
809c0e8cc1aSIngo Weinhold		set_default_value HAIKU_ARFLAGS_$targetArch		cru
810c0e8cc1aSIngo Weinhold		set_default_value HAIKU_UNARFLAGS_$targetArch	x
811338b8dc3SIngo Weinhold
812c0e8cc1aSIngo Weinhold		# Override the cross tools variables, if the tools were built or a
813c0e8cc1aSIngo Weinhold		# prefix was specified.
814b7777272SAlex Smith		if [ -n "$crossToolsPrefix" ]; then
815c0e8cc1aSIngo Weinhold			get_build_tool_path AR_$targetArch ${crossToolsPrefix}ar
816c0e8cc1aSIngo Weinhold			get_build_tool_path LD_$targetArch ${crossToolsPrefix}ld
817c0e8cc1aSIngo Weinhold			get_build_tool_path OBJCOPY_$targetArch ${crossToolsPrefix}objcopy
818c0e8cc1aSIngo Weinhold			get_build_tool_path RANLIB_$targetArch ${crossToolsPrefix}ranlib
819c0e8cc1aSIngo Weinhold			get_build_tool_path STRIP_$targetArch ${crossToolsPrefix}strip
820c0e8cc1aSIngo Weinhold
821c0e8cc1aSIngo Weinhold			case `get_variable HAIKU_GCC_RAW_VERSION_$targetArch` in
822bd16f0ddSAlex Smith				4.*)
823c0e8cc1aSIngo Weinhold					get_build_tool_path ELFEDIT_$targetArch \
824c0e8cc1aSIngo Weinhold						${crossToolsPrefix}elfedit
825bd16f0ddSAlex Smith				;;
826bd16f0ddSAlex Smith			esac
82752a38012Sejakowatz		fi
82852a38012Sejakowatz
829c0e8cc1aSIngo Weinhold		# Get the libgcc objects. We couldn't do that in standard_gcc_settings,
830c0e8cc1aSIngo Weinhold		# since we need "ar", which may be set later.
831c0e8cc1aSIngo Weinhold		ar=`get_variable HAIKU_AR_$targetArch`
832c0e8cc1aSIngo Weinhold		libgcc=`get_variable HAIKU_GCC_LIBGCC_$targetArch`
833c0e8cc1aSIngo Weinhold		set_variable HAIKU_GCC_LIBGCC_OBJECTS_$targetArch \
834c0e8cc1aSIngo Weinhold			"`$ar t $libgcc | grep -v eabi.o`"
835c0e8cc1aSIngo Weinhold			# Note: We filter out eabi.o. It's present in gcc's libgcc for PPC
836c0e8cc1aSIngo Weinhold			# and neither needed nor wanted.
837c0e8cc1aSIngo Weinhold
838ef57df3dSIngo Weinhold		# check whether the Haiku compiler really targets Haiku
839c0e8cc1aSIngo Weinhold		targetMachine=`get_variable HAIKU_GCC_MACHINE_$targetArch`
840c0e8cc1aSIngo Weinhold		case "$targetMachine" in
841eedc3d0bSIngo Weinhold			*-*-haiku)	;;
842c0e8cc1aSIngo Weinhold			*)
843c0e8cc1aSIngo Weinhold				echo The compiler specified as Haiku target compiler is not a \
844c0e8cc1aSIngo Weinhold				valid Haiku cross-compiler. Please see ReadMe.cross-compile. >&2
845eedc3d0bSIngo Weinhold				echo compiler: $HAIKU_CC
846c0e8cc1aSIngo Weinhold				echo compiler is configured for target: $targetMachine
847eedc3d0bSIngo Weinhold				exit 1 ;;
848eedc3d0bSIngo Weinhold		esac
849c0e8cc1aSIngo Weinhold
850c0e8cc1aSIngo Weinhold		HAIKU_PACKAGING_ARCHS="$HAIKU_PACKAGING_ARCHS $targetArch"
85168ccc989SIngo Weinhold		isPrimaryArch=
852c0e8cc1aSIngo Weinhold	done
8532ebcd86dSIngo Weinholdfi
854eedc3d0bSIngo Weinhold
85552a38012Sejakowatz# Generate BuildConfig
8567c4641d0SOliver Tappecat << EOF > "$buildConfigFile"
85752a38012Sejakowatz# BuildConfig
858ab2540c4SIngo Weinhold# Note: This file has been automatically generated by configure with the
859ab2540c4SIngo Weinhold# following arguments:
86055d267a4SFrançois Revol# ${configureArgs}
86152a38012Sejakowatz
8627c4641d0SOliver TappeTARGET_PLATFORM 			?= "${TARGET_PLATFORM}" ;
8637c4641d0SOliver TappeHOST_PLATFORM				?= "${HOST_PLATFORM}" ;
864338b8dc3SIngo Weinhold
8657c4641d0SOliver TappeHAIKU_INCLUDE_GPL_ADDONS			?= "${HAIKU_INCLUDE_GPL_ADDONS}" ;
8667c4641d0SOliver TappeHAIKU_INCLUDE_PATENTED_CODE			?= "${HAIKU_INCLUDE_PATENTED_CODE}" ;
86776fa0be3SIngo WeinholdHAIKU_INCLUDE_SOURCES				?= "${HAIKU_INCLUDE_SOURCES}" ;
8687c4641d0SOliver TappeHAIKU_INCLUDE_3RDPARTY				?= "${HAIKU_INCLUDE_3RDPARTY}" ;
8697c4641d0SOliver TappeHAIKU_ENABLE_MULTIUSER				?= "${HAIKU_ENABLE_MULTIUSER}" ;
8707c4641d0SOliver TappeHAIKU_DISTRO_COMPATIBILITY			?= "${HAIKU_DISTRO_COMPATIBILITY}" ;
8717c4641d0SOliver TappeHAIKU_USE_GCC_PIPE					?= "${HAIKU_USE_GCC_PIPE}" ;
8727986925fSIngo WeinholdHAIKU_HOST_USE_32BIT				?= "${HAIKU_HOST_USE_32BIT}" ;
8737986925fSIngo WeinholdHAIKU_HOST_USE_XATTR				?= "${HAIKU_HOST_USE_XATTR}" ;
874bc96e8f3SIngo WeinholdHAIKU_HOST_USE_XATTR_REF			?= "${HAIKU_HOST_USE_XATTR_REF}" ;
8752ebcd86dSIngo WeinholdHAIKU_HOST_BUILD_ONLY				?= "${HAIKU_HOST_BUILD_ONLY}" ;
876eccc7665SIngo Weinhold
877c0e8cc1aSIngo WeinholdHAIKU_PACKAGING_ARCHS		?= ${HAIKU_PACKAGING_ARCHS} ;
87865ad1ba3SAlex Smith
8797c4641d0SOliver TappeHAIKU_BUILD_ATTRIBUTES_DIR	?= ${HAIKU_BUILD_ATTRIBUTES_DIR} ;
880338b8dc3SIngo Weinhold
88177e84f21SIngo WeinholdHAIKU_YASM					?= ${HAIKU_YASM} ;
882338b8dc3SIngo Weinhold
883f04f7042SNiels Sascha ReedijkHOST_EXTENDED_REGEX_SED		?= ${HOST_EXTENDED_REGEX_SED} ;
8847c4641d0SOliver TappeHOST_GCC_RAW_VERSION		?= ${HOST_GCC_RAW_VERSION} ;
8857c4641d0SOliver TappeHOST_GCC_MACHINE			?= ${HOST_GCC_MACHINE} ;
8867c4641d0SOliver TappeHOST_LD						?= ${HOST_GCC_LD} ;
8877c4641d0SOliver TappeHOST_OBJCOPY				?= ${HOST_GCC_OBJCOPY} ;
888c505b276SFrançois RevolHOST_SFDISK					?= ${HOST_SFDISK} ;
8892a5d0aafSIngo WeinholdHOST_SHA256					?= ${HOST_SHA256} ;
8908b5934c9SIngo Weinhold
891e173a1ecSIngo WeinholdHOST_HAIKU_PORTER			?= ${HOST_HAIKU_PORTER} ;
892e173a1ecSIngo WeinholdHAIKU_PORTS					?= ${HAIKU_PORTS} ;
893e173a1ecSIngo WeinholdHAIKU_PORTS_CROSS			?= ${HAIKU_PORTS_CROSS} ;
894e173a1ecSIngo Weinhold
895c4786ea6SlilloEOF
896c4786ea6Slillo
897c0e8cc1aSIngo Weinholdfor targetArch in $HAIKU_PACKAGING_ARCHS; do
898c0e8cc1aSIngo Weinhold	variables="
899c0e8cc1aSIngo Weinhold		HAIKU_GCC_RAW_VERSION		HAIKU_GCC_RAW_VERSION
900c0e8cc1aSIngo Weinhold		HAIKU_GCC_MACHINE			HAIKU_GCC_MACHINE
901c0e8cc1aSIngo Weinhold		HAIKU_GCC_LIB_DIR			HAIKU_GCC_LIB_DIR
902c0e8cc1aSIngo Weinhold		HAIKU_GCC_LIBGCC			HAIKU_GCC_LIBGCC
903c0e8cc1aSIngo Weinhold		HAIKU_CPU					HAIKU_CPU
904c0e8cc1aSIngo Weinhold		HAIKU_STATIC_LIBSTDC++		HAIKU_STATIC_LIBSTDCXX
905c0e8cc1aSIngo Weinhold		HAIKU_SHARED_LIBSTDC++		HAIKU_SHARED_LIBSTDCXX
906c0e8cc1aSIngo Weinhold		HAIKU_STATIC_LIBSUPC++		HAIKU_STATIC_LIBSUPCXX
907c0e8cc1aSIngo Weinhold		HAIKU_SHARED_LIBSUPC++		HAIKU_SHARED_LIBSUPCXX
908c0e8cc1aSIngo Weinhold		HAIKU_KERNEL_LIBGCC			HAIKU_KERNEL_LIBGCC
909c0e8cc1aSIngo Weinhold		HAIKU_KERNEL_LIBSUPC++		HAIKU_KERNEL_LIBSUPCXX
910c0e8cc1aSIngo Weinhold		HAIKU_BOOT_LIBGCC			HAIKU_BOOT_LIBGCC
911c0e8cc1aSIngo Weinhold		HAIKU_BOOT_LIBSUPC++		HAIKU_BOOT_LIBSUPCXX
912c0e8cc1aSIngo Weinhold		HAIKU_AR					HAIKU_AR
913c0e8cc1aSIngo Weinhold		HAIKU_CC					HAIKU_CC
914c0e8cc1aSIngo Weinhold		HAIKU_LD					HAIKU_LD
915c0e8cc1aSIngo Weinhold		HAIKU_OBJCOPY				HAIKU_OBJCOPY
916c0e8cc1aSIngo Weinhold		HAIKU_RANLIB				HAIKU_RANLIB
917c0e8cc1aSIngo Weinhold		HAIKU_ELFEDIT				HAIKU_ELFEDIT
918c0e8cc1aSIngo Weinhold		HAIKU_STRIP					HAIKU_STRIP
919c0e8cc1aSIngo Weinhold		HAIKU_CPPFLAGS				HAIKU_CPPFLAGS
920c0e8cc1aSIngo Weinhold		HAIKU_CCFLAGS				HAIKU_CCFLAGS
921c0e8cc1aSIngo Weinhold		HAIKU_C++FLAGS				HAIKU_CXXFLAGS
922c0e8cc1aSIngo Weinhold		HAIKU_LDFLAGS				HAIKU_LDFLAGS
923c0e8cc1aSIngo Weinhold		HAIKU_ARFLAGS				HAIKU_ARFLAGS
924c0e8cc1aSIngo Weinhold		HAIKU_UNARFLAGS				HAIKU_UNARFLAGS
925c0e8cc1aSIngo Weinhold		HAIKU_USE_GCC_GRAPHITE		HAIKU_USE_GCC_GRAPHITE
926c0e8cc1aSIngo Weinhold		"
927c0e8cc1aSIngo Weinhold	set -- $variables
928c0e8cc1aSIngo Weinhold	while [ $# -ge 2 ]; do
929c0e8cc1aSIngo Weinhold		value=`get_variable ${2}_$targetArch`
930c0e8cc1aSIngo Weinhold		echo "${1}_${targetArch} ?= $value ;" >> "$buildConfigFile"
931c0e8cc1aSIngo Weinhold		shift 2
932c0e8cc1aSIngo Weinhold	done
933b1e5b60cSAxel Dörfler
934c0e8cc1aSIngo Weinhold	# For variables that may have long values, distribute them over multiple
935c0e8cc1aSIngo Weinhold	# lines so that jam doesn't hit the maximum line length.
936c0e8cc1aSIngo Weinhold	variables="
937c0e8cc1aSIngo Weinhold		HAIKU_GCC_HEADERS_DIR		HAIKU_GCC_HEADERS_DIR
938c0e8cc1aSIngo Weinhold		HAIKU_C++_HEADERS_DIR		HAIKU_CXX_HEADERS_DIR
93966a7f29fSJérôme Duval		HAIKU_BOOT_C++_HEADERS_DIR	HAIKU_BOOT_CXX_HEADERS_DIR
940c0e8cc1aSIngo Weinhold		HAIKU_GCC_LIBGCC_OBJECTS	HAIKU_GCC_LIBGCC_OBJECTS
941c0e8cc1aSIngo Weinhold		"
942c0e8cc1aSIngo Weinhold	set -- $variables
943c0e8cc1aSIngo Weinhold	while [ $# -ge 2 ]; do
944c0e8cc1aSIngo Weinhold		echo "${1}_${targetArch} ?= " >> "$buildConfigFile"
945c0e8cc1aSIngo Weinhold		get_variable ${2}_$targetArch | xargs -n 1 echo "   " \
946c0e8cc1aSIngo Weinhold			>> "$buildConfigFile"
947c0e8cc1aSIngo Weinhold		echo "    ;" >> "$buildConfigFile"
948c0e8cc1aSIngo Weinhold		shift 2
949c0e8cc1aSIngo Weinhold	done
950c0e8cc1aSIngo Weinholddone
951b1e5b60cSAxel Dörfler
952b1e5b60cSAxel Dörfler
9539b0dd528SIngo Weinhold# Generate a boot strap Jamfile in the output directory.
954338b8dc3SIngo Weinhold
955338b8dc3SIngo Weinholdcat << EOF > $outputDir/Jamfile
956338b8dc3SIngo Weinhold# automatically generated Jamfile
957338b8dc3SIngo Weinhold
958338b8dc3SIngo WeinholdHAIKU_TOP			= ${sourceDir} ;
959338b8dc3SIngo WeinholdHAIKU_OUTPUT_DIR	= ${outputDir} ;
960338b8dc3SIngo Weinhold
961338b8dc3SIngo Weinholdinclude [ FDirName \$(HAIKU_TOP) Jamfile ] ;
962338b8dc3SIngo Weinhold
963338b8dc3SIngo WeinholdEOF
964